#include <iomanip>
#include <iostream>
#include <cmath>
#ifdef OFFICE_OUTPUT
#define iterout(x) cout<<#x<<'_'<<iter<<" = "<<x<<endl<<"newline"<<endl
#else
#define iterout(x) cout<<#x<<iter<<" = "<<x<<endl
#endif
#define yiter 0.5-cos(x-1)
#define xiter 3+cos(y)
#define MAX_ITER 60000
#define f1(x,y)(cos(x-1)+y-0.5)
#define f2(x,y)(x-cos(y)-3)
#define f1x(x,y)(-sin(x-1))
#define f1y(x,y)1
#define f2x(x,y)1
#define f2y(x,y)(sin(y))
using namespace std;
void newton(float x, float y, float e) {
    unsigned short iter=0;
    float dx, dy, delta,fx,fy,det;
    while(abs(dx)+abs(dy)>e\
               &&iter<MAX_ITER||!iter){    
        fx = f1(x, y);
        fy = f2(x, y);
        det = f1x(x,y) * f2y(x, y) - f1y(x, y) * f2x(x, y);
        dx = (fx * f2y(x, y) - fy * f1y(x, y)) / det;
        dy = (f1x(x,y) * fy - f2x(x, y) * fx) / det;
        x -= dx;
        y -= dy;
        iterout(x);
        iterout(y);
        iter++;
    }
}
void simple(float x,float y,float e){
    float newx=x;
    float newy=y;
    unsigned short iter=0;
    iterout(x);
    while(abs(newy-y)+abs(newx-x)>e\
               &&iter<MAX_ITER||!iter){
        iterout(y);
        newy=yiter;
        iter++;
        newx=xiter;
        swap(newx,x);
        swap(newy,y);
        cout<<endl;
        iterout(x);
    }
}
int main()
{

    float x,y,e;
#ifdef INPUT0
    cout << "x0?" << endl;
    cin>>x;
    cout << "y0?" << endl;
    cin>>x;
#else
x=3.35;
y=1.2;
#endif
    cout<<"e?: ";cin>>e;
    std::cout<<setprecision(log10(1/e)+2);
    cout<<endl<<"Simple iteration:"<<endl;
    simple(x,y,e);
    cout<<endl<<"Newton's method:"<<endl;
    newton(x,y,e);
    return 0;
}
